/*
 *  XASSERT.C - Extended assert macro.
 *  Written 1995-1997 by Andrew Clarke and released to the public domain.
 */

#include <stdlib.h>
#include "xmalloc.h"
#include "xassert.h"

static int asserting = 1;

void xsetassert(int set)
{
    asserting = set;
}

int pxassertfail(char *expr, char *srce_fn, unsigned long srce_ln)
{
    if (asserting)
    {
        error("%s(%lu) : Assertion failed: %s", srce_fn, srce_ln, expr);
        exit(0);
    }
    return 1;
}
